/**
 * Numbo is a Javascript library to convert number and monetary amount
 * to written text in multiple languages.
 * Also helpful for writing cheques (checks). Supports English, and 支援中文.
 * 
 * Numbo is open source in:
 * https://github.com/Edditoria/numbo
 * 
 * @author Edditoria
 * @license MIT
 * Code released under the MIT license:
 * https://github.com/Edditoria/numbo/blob/master/LICENSE.txt
 * 
 */

(function(g,f){typeof exports==="object"&&typeof module!=="undefined"?module.exports=f():typeof define==="function"&&define.amd?define(f):(g=typeof globalThis!=="undefined"?globalThis:g||self,g.numbo=f())})(this,(function(){"use strict";function check(input){var acceptRegex,commaAfterDot,dotCount,illegalStr,inputStr,result;result=false;inputStr=input.toString();acceptRegex=/^[\+\-\$]*[\d\.\,]*|[\d\.\,]*/g;illegalStr=inputStr.replace(acceptRegex,"");dotCount=(inputStr.match(/\./g)||[]).length;commaAfterDot=inputStr.indexOf(",",inputStr.indexOf("."))>0;if(illegalStr===""&&dotCount<2&&!commaAfterDot){result=true}return result}function splitNum(input){var output;if(typeof input!=="string"){input=input.toString()}if(input.indexOf(".")===-1){output=[input,""]}else{output=input.split(".")}if(output[0]===""){output[0]="0"}return output}function normalize(input){var dotIndex,inputArr,output,regexHead,regexTail;if(typeof input!=="string"){input=input.toString()}regexHead=/,|^[$|\-]*(0|,)*(?!\.)/g;regexTail=/0*$/g;dotIndex=input.indexOf(".");if(dotIndex===-1){output=input.replace(regexHead,"")}else{inputArr=splitNum(input);inputArr[0]=inputArr[0].replace(regexHead,"");inputArr[1]=inputArr[1].replace(regexTail,"");output=inputArr.join(".")}if(output.indexOf(".")===0){output="0"+output}if(output===""){output="0"}return output.replace(/\.$/,"")}function adjustDecimal(str){var type=arguments.length>1&&arguments[1]!==undefined?arguments[1]:"ceil";var dp=arguments.length>2&&arguments[2]!==undefined?arguments[2]:2;var carryInt,dec,dotIndex,int,parseDec;if(typeof str!=="string"){str=str.toString()}dotIndex=str.indexOf(".");if(dotIndex===-1){return str}if(type!=="ceil"&&type!=="floor"&&type!=="round"){type="ceil";console.log("Error: type in adjustDecimal() is invalid. Use the default option (Math.ceil)")}if(typeof dp!=="number"||dp<0){dp=2;console.log("Error: dp in adjustDecimal() is invalid. Use the default option (adjust to 2 decimal place)")}parseDec=function parseDec(dec,type,dp){dec="0."+dec;dec=Math[type](+(dec+"e+"+dp));dec=+(dec+"e-"+dp);if(dec===0){return""}else if(dec===1){return"1"}else{return(dec+"").replace(/^0/g,"")}};carryInt=function carryInt(int){var index,intArr,isCarry,len,thisChar;len=int.length;if(len<16){return+int+1+""}else{intArr=int.split("");index=len;isCarry=true;while(index&&isCarry){index--;thisChar=+intArr[index]+1+"";if(thisChar==="10"){thisChar="0"}else{isCarry=false}intArr[index]=thisChar}if(isCarry){intArr.unshift("1")}return intArr.join("")}};if(type==="ceil"||type==="round"){int=str.slice(0,dotIndex);dec=str.slice(dotIndex+1);dec=parseDec(dec,type,dp);if(dec==="1"){dec="";int=carryInt(int)}return int+dec}else if(type==="floor"){int=str.slice(0,dotIndex);dec=str.slice(dotIndex,dotIndex+dp+1);if(+dec===0){dec=""}return int+dec}else{console.log("Error: Unknown error in adjustDecimal()");return str}}function speakByDigit(str,n1){var separator=arguments.length>2&&arguments[2]!==undefined?arguments[2]:" ";var i,item,len,output;if(typeof str==="string"&&str.search(/\D/g)<0){output=[];for(i=0,len=str.length;i<len;i++){item=str[i];output.push(n1[+item])}return output.join(separator)}else{console.log("Error: Invalid argument of speakByDigit()");return null}}function splitInt(int){var digit=arguments.length>1&&arguments[1]!==undefined?arguments[1]:3;var intTail,len,output,times;if(typeof int!=="string"){int=int.toString()}output=[];times=Math.ceil(int.length/digit);while(times){len=int.length;intTail=int.substring(len-digit,len);int=int.substring(0,len-digit);output.unshift(intTail);times--}return output}function parseCents(dec){return(dec+"000").slice(0,2)}var n1,n10,n10Simple,n1Simple,nLarge,speak9999,speakAmt,speakInt,speakNum;n1=["零","壹","贰","叁","肆","伍","陆","柒","捌","玖"];n1Simple=["零","一","二","三","四","五","六","七","八","九"];n10=["","拾","佰","仟"];n10Simple=["","十","百","千"];nLarge=["","万","亿","兆","京","垓","秭","穰","沟","涧","正","载"];speak9999=function speak9999(str){var isSimple=arguments.length>1&&arguments[1]!==undefined?arguments[1]:true;var eachNum,i,num,output,ref,speakN1,speakN10,times,unit;speakN1=isSimple?n1Simple:n1;speakN10=isSimple?n10Simple:n10;times=str.length-1;output="";for(num=i=0,ref=times;0<=ref?i<=ref:i>=ref;num=0<=ref?++i:--i){eachNum=+str[num];unit=eachNum===0?"":speakN10[times-num];output+=speakN1[eachNum]+unit}if(output==="零零零零"){return"零"}else{return output.replace(/\零+$/g,"")}};speakInt=function speakInt(str){var isSimple=arguments.length>1&&arguments[1]!==undefined?arguments[1]:true;var i,item,itemNum,len,num,output,speakItem,strArr,times,unit;if(str==="0"){return"零"}strArr=splitInt(str,4);times=strArr.length-1;output="";for(num=i=0,len=strArr.length;i<len;num=++i){item=strArr[num];speakItem=speak9999(item,isSimple);if(num===0){itemNum=parseInt(item,10);if(itemNum>9&&itemNum<20){speakItem=speakItem.replace(/^[\一\壹]|\零/g,"")}}unit=speakItem==="零"?"":nLarge[times-num];output+=speakItem+unit}return output.replace(/\零+$/g,"").replace(/\零+/g,"零")};speakNum=function speakNum(str){var dec,dot,int,strSplited;strSplited=splitNum(str);int=strSplited[0];dec=strSplited[1];dot=dec===""?"":"点";return speakInt(int,true)+dot+speakByDigit(dec,n1Simple,"")};speakAmt=function speakAmt(str){var options=arguments.length>1&&arguments[1]!==undefined?arguments[1]:"cheque";var cent,cent1,cent2,dec,dollar,dp1,dp2,int,isSimple,speakN1,strSplited;str=adjustDecimal(str,"ceil",2);strSplited=splitNum(str);int=strSplited[0];dec=+parseCents(strSplited[1]);if(int==="0"&&dec===0){return"零元"}isSimple=options==="cheque"?false:true;dollar=int==="0"?"":int==="2"&&options!=="cheque"?"两元":speakInt(int,isSimple)+"元";cent=dec===0?options==="cheque"?"整":"":(speakN1=isSimple?n1Simple:n1,dp1=Math.floor(dec/10),dp2=dec%10,cent1=dp1===0?"":dp1===2&&options!=="cheque"?"两角":speakN1[dp1]+"角",cent2=dp2===0?"":dp2===2&&options!=="cheque"?"两分":speakN1[dp2]+"分",cent=cent1+cent2);return dollar+cent};function zhCn(input){var options=arguments.length>1&&arguments[1]!==undefined?arguments[1]:{type:"number"};if(input===""){return null}if(input==="1e+100"){return"Ding! One Google... Oops... One Googol!!"}if(check(input)===false){console.log("Error: Invalid input value. Return null");return null}input=normalize(input);switch(options.type){case null:case"number":case"num":return speakNum(input);case"cheque":case"check":case"chk":case"chq":return speakAmt(input,"cheque");case"amount":case"amt":return speakAmt(input,"amount");default:console.log("Error: Option in zhCN is not valid");return null}}return zhCn}));